
function buildOptions(name, addon)
  return {
    name = name,
    handler = addon,
    type = "group",
    set = "SetOption",
    get = "GetOption",
    args = {
      description = {
        order = 1,
        type = "description",
        name = "WardrobeMalfunction provides you with critical, time-sensitive feedback on your current transmog."
      },
      display_settings = {
        order = 2,
        type = "group",
        name = "Display Settings",
        inline = true,
        args = {
          help = {
            type = "description",
            name = "The display of the flashing border can be customized by changing the options below.",
            order = 1,
          },
          flash_border = {
            order = 2,
            type = "toggle",
            name = "Flash Border",
            desc = "Flash border upon wardrobe malfunction?",
            arg = "flashBorder",
          },
          border_color = {
            order = 3,
            type = "color",
            name = "Border color",
            desc = "The color of the flashing border.",
            set = "SetBorderColor",
            get = "GetBorderColor"
          },
        }
      },
      sound_settings = {
        order = 3,
        type = "group",
        name = "Sound Settings",
        inline = true,
        args = {
          help = {
            order = 1,
            type = "description",
            name = "Sounds can be customized by changing the options below.",
          },
          play_sound = {
            order = 2,
            type = "toggle",
            name = "Play Sound",
            desc = "Play sound upon wardrobe malfunction?",
            arg = "playSound",
          },
          sound_select = {
            order = 3,
            type = "select",
            name = "Sound",
            desc = "The sound to play when the unspeakable happens.",
            arg = "sound",
            values = {
              ["raidwarning"] = "Raid Warning",
              ["raidbosswarning"] = "Raid Boss Warning",
              ["raidbosswhisperwarning"] = "Raid Boss Whisper Warning",
              ["timgunn"] = "Tim Gunn",
            }
          },
          test_sound = {
            type = "execute",
            order = 4,
            name = "Play",
            desc = "Test the selected sound.",
            func = function(info)
              PlaySoundFile(SOUNDS[info.handler.db.profile.sound], "Master")
            end
          },
        },
      },
      transmog_settings = {
        order = 4,
        type = "group",
        name = "Transmogs",
        inline = true,
        args = {
          group_1 = {
            order = 1,
            type = "group",
            name = "",
            args = {
              auto_save = {
                order = 1,
                type = "toggle",
                name = "Auto-save transmog",
                desc = "Automatically save when applying transmog at a Transmogrifier",
                arg = "autoSave"
              },
              check_leveling = {
                order = 2,
                type = "toggle",
                name = "Check while leveling",
                desc = "Check for wardrobe malfunctions while leveling this toon?",
                arg = "checkLeveling"
              },
            }
          },
          group_2 = {
            order = 2,
            type = "group",
            name = "",
            args = {
              clear_outfits = {
                order = 1,
                type = "execute",
                name = "Clear Saved",
                desc = "Clear saved transmogs for all specs.",
                func = function(info)
                  info.handler:ClearAllOutfits()
                end
              }
            }
          }
        }
      },
      help_group = {
        order = 5,
        type = "group",
        name = "Chat Commands",
        inline = true,
        args = {
          group_1 = {
            order = 1,
            type = "group",
            name = "",
            inline = true,
            args = {
              help_text_1 = {
                order = 1,
                type = "description",
                name = "/wama clear - clears all saved transmogs"
              },
              help_text_2 = {
                order = 2,
                type = "description",
                name = "/wama list - lists saved transmogs"
              },
              help_text_3 = {
                order = 3,
                type = "description",
                name = "/wama save - saves current transmog"
              },
            },
          },
        },
      },
    }
  }
end

